var NAVTREE =
[
  [ "GNU Radio 3.6.4.1 C++ API", "index.html", [
    [ "Building GNU Radio", "index.html#build", null ],
    [ "GNU Radio Blocks", "index.html#blocks", null ],
    [ "Manual Contents", "index.html#toc", null ],
    [ "Operating a Flowgraph", "index.html#flowgraph", [
      [ "Latency and Throughput", "index.html#latency", null ]
    ] ],
    [ "Reconfiguring Flowgraphs", "index.html#reconfigure", null ],
    [ "Using Volk in GNU Radio", "index.html#volk_main", null ],
    [ "Configuration / Preference Files", "index.html#prefs", null ],
    [ "Build Instructions and Information", "build_guide.html", [
      [ "Dependencies", "build_guide.html#dependencies", [
        [ "Global Dependencies", "build_guide.html#dep_global", null ],
        [ "Python Wrappers", "build_guide.html#dep_python", null ],
        [ "docs: Building the documentation", "build_guide.html#dep_docs", null ],
        [ "grc: The GNU Radio Companion", "build_guide.html#dep_grc", null ],
        [ "gr-wavelet: Collection of wavelet blocks", "build_guide.html#dep_wavelet", null ],
        [ "gr-qtgui: The QT-based Graphical User Interface", "build_guide.html#dep_gr_qtgui", null ],
        [ "gr-wxgui: The WX-based Graphical User Interface", "build_guide.html#dep_gr_wxgui", null ],
        [ "gr-audio: Audio Subsystems (system/OS dependent)", "build_guide.html#dep_gr_audio", null ],
        [ "uhd: The Ettus USRP Hardware Driver Interface", "build_guide.html#dep_uhd", null ],
        [ "shd: The Symplex Hardware Driver Interface", "build_guide.html#dep_shd", null ],
        [ "gr-video-sdl: PAL and NTSC display", "build_guide.html#dep_gr_video_sdl", null ],
        [ "gr-comedi: Comedi hardware interface", "build_guide.html#dep_gr_comedi", null ]
      ] ],
      [ "Building GNU Radio", "build_guide.html#build_gr_cmake", [
        [ "Options", "build_guide.html#Cmake", null ],
        [ "Building for the E100", "build_guide.html#build_gr_cmake_e100", null ]
      ] ]
    ] ],
    [ "Instructions for using Volk in GNU Radio", "volk_guide.html", [
      [ "Introduction", "volk_guide.html#volk_intro", null ],
      [ "Setting and Using Memory Alignment Information", "volk_guide.html#volk_alignment", null ],
      [ "Using Alignment Properties in Work()", "volk_guide.html#volk_work", null ],
      [ "Tuning Volk Performance", "volk_guide.html#volk_tuning", [
        [ "Hand-Tuning Performance", "volk_guide.html#volk_hand_tuning", null ]
      ] ]
    ] ],
    [ "Metadata Information", "page_metadata.html", [
      [ "Introduction", "page_metadata.html#Introduction", [
        [ "Types of Metadata Files", "page_metadata.html#types", null ],
        [ "Updating Headers", "page_metadata.html#updating", null ],
        [ "Implementation", "page_metadata.html#implementation", null ]
      ] ],
      [ "Structure", "page_metadata.html#structure", [
        [ "Header Information", "page_metadata.html#header", null ],
        [ "Extras Information", "page_metadata.html#extras", null ]
      ] ],
      [ "Utilities", "page_metadata.html#Utilities", null ],
      [ "Examples", "page_metadata.html#Examples", null ]
    ] ],
    [ "Message Passing", "page_msg_passing.html", [
      [ "Introduction", "page_msg_passing.html#intro", null ],
      [ "Message Passing API", "page_msg_passing.html#api", null ],
      [ "Code Examples", "page_msg_passing.html#examples", null ],
      [ "Posting from External Sources", "page_msg_passing.html#posting", null ]
    ] ],
    [ "Polyphase Filterbanks", "page_pfb.html", [
      [ "Introduction", "page_pfb.html#Introduction", null ],
      [ "Usage", "page_pfb.html#Usage", null ],
      [ "Examples", "page_pfb.html#Examples", null ]
    ] ],
    [ "Polymorphic Types", "page_pmt.html", [
      [ "Introduction", "page_pmt.html#intro", null ],
      [ "PMT Data Type", "page_pmt.html#datatype", null ],
      [ "Inserting and Extracting Data", "page_pmt.html#insert", null ],
      [ "Strings", "page_pmt.html#strings", null ],
      [ "Tests and Comparisons", "page_pmt.html#tests", null ],
      [ "Dictionaries", "page_pmt.html#dict", null ],
      [ "Vectors", "page_pmt.html#vectors", [
        [ "BLOB", "page_pmt.html#blob", null ]
      ] ],
      [ "Pairs", "page_pmt.html#pairs", null ],
      [ "Serializing and Deserializing", "page_pmt.html#serdes", null ],
      [ "Printing", "page_pmt.html#printing", null ]
    ] ],
    [ "Block Thread Affinity", "page_affinity.html", [
      [ "Introduction", "page_affinity.html#intro", null ],
      [ "GNU Radio Block API", "page_affinity.html#affinity_api", null ]
    ] ],
    [ "Analog Modulation", "page_analog.html", [
      [ "Introduction", "page_analog.html#Introduction", null ]
    ] ],
    [ "Audio Interface", "page_audio.html", [
      [ "Introduction", "page_audio.html#Introduction", null ],
      [ "Usage", "page_audio.html#Usage", null ]
    ] ],
    [ "Digital Modulation", "page_digital.html", [
      [ "Introduction", "page_digital.html#Introduction", null ]
    ] ],
    [ "FunCube Dongle Source", "page_fcd.html", [
      [ "Introduction", "page_fcd.html#Introduction", null ],
      [ "Dependencies", "page_fcd.html#Dependencies", null ]
    ] ],
    [ "FFT Signal Processing Blocks", "page_fft.html", [
      [ "Introduction", "page_fft.html#Introduction", null ],
      [ "Dependencies", "page_fft.html#Dependencies", null ]
    ] ],
    [ "filter Signal Processing Blocks", "page_filter.html", [
      [ "Introduction", "page_filter.html#Introduction", null ],
      [ "Dependencies", "page_filter.html#Dependencies", null ]
    ] ],
    [ "QT Graphical User Interface", "page_qtgui.html", [
      [ "Introduction", "page_qtgui.html#Introduction", null ],
      [ "Dependencies", "page_qtgui.html#Dependencies", null ],
      [ "Usage", "page_qtgui.html#Usage", null ]
    ] ],
    [ "UHD Interface", "page_uhd.html", [
      [ "Introduction", "page_uhd.html#Introduction", null ],
      [ "Documentation", "page_uhd.html#External", null ],
      [ "Setup", "page_uhd.html#Typical", null ]
    ] ],
    [ "Voice Coders and Decoders (Vocoders)", "page_vocoder.html", [
      [ "Introduction", "page_vocoder.html#Introduction", null ]
    ] ],
    [ "Modules", "modules.html", "modules" ],
    [ "Namespaces", null, [
      [ "Namespace List", "namespaces.html", "namespaces" ],
      [ "Namespace Members", "namespacemembers.html", [
        [ "All", "namespacemembers.html", "namespacemembers_dup" ],
        [ "Functions", "namespacemembers_func.html", "namespacemembers_func" ],
        [ "Variables", "namespacemembers_vars.html", null ],
        [ "Typedefs", "namespacemembers_type.html", null ],
        [ "Enumerations", "namespacemembers_enum.html", null ],
        [ "Enumerator", "namespacemembers_eval.html", null ]
      ] ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", null ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", null ],
        [ "Related Functions", "functions_rela.html", "functions_rela" ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", "globals_func" ],
        [ "Variables", "globals_vars.html", "globals_vars" ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", "globals_eval" ],
        [ "Macros", "globals_defs.html", "globals_defs" ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"__kiss__fft__guts_8h.html",
"base_8h.html#ae239e05c27cc307f788a030d7198dbe3",
"classatsci__data__interleaver.html",
"classcomedi__sink__s.html#a1e267c1c193ef6dc2c743c66f802aaa5",
"classdigital__fll__band__edge__cc.html#acadafb1a31af91565c94c0d579337a45",
"classdigital__pfb__clock__sync__ccf.html#a2a3c47923d5a62ca6cddf112d6691f2a",
"classgr_1_1analog_1_1agc__ff__impl.html#a0a0eea706eba05dc8d02889595a3cb39",
"classgr_1_1analog_1_1pll__carriertracking__cc__impl.html#a903f035a85d77151f4256a5bdb24e2d2",
"classgr_1_1analog_1_1squelch__base__cc__impl.html#aa9e3c51bd9bfa96553dc58b6aff2a56a",
"classgr_1_1blocks_1_1multiply__cc.html#a29c014c94d4d5ff388c2ee6339fd4e24",
"classgr_1_1fft_1_1fft__real__rev.html#aeae7baa8f9427bc208ecac1943d75c32",
"classgr_1_1filter_1_1kernel_1_1fir__filter__ccf.html",
"classgr_1_1filter_1_1pfb__decimator__ccf.html#a0c2c0952e4cd3dafdfd5c5b0c9826df7",
"classgr__basic__block.html#a043ae7d3ce7e8cc41bd2e98823f7d7d8",
"classgr__block__gateway.html#af574d027a0db904111e8cb0412cd336f",
"classgr__edge.html#a7729fa9d896b7e0133573d18038a1a46",
"classgr__fir__ccf__armv7__a.html#a448c85dfefd3c8d75aa715c2a2204010",
"classgr__fir__sysconfig__powerpc.html#a24358fa9bad048338626af85b39a4162",
"classgr__fxpt__vco.html",
"classgr__message__burst__source.html#ae2aceb2584fba9416f12a44cb210f058",
"classgr__ofdm__frame__sink2.html#a880f9d222443c9999d449dcbfc9c7948",
"classgr__pfb__clock__sync__fff.html#a492a431a8541bdbb503aae72e4b11893",
"classgr__rational__resampler__base__fff.html#a1ff0be0794d415b229423926c9c60998",
"classgr__stream__pdu__base.html#a51d30d6357cccac6332f51e1ed86eb5f",
"classgr__vector__sink__i.html#a8c37d02e82149e3c4851e3c9bb3311c0",
"classgri__fft__filter__fff__sse.html#aa37162dc478ec4389bf4bc2b1a28ee0f",
"classmicrotune__4702__eval__board.html#a5e98afa535aa856d472b9448d77de908",
"classpmt_1_1pmt__s64vector.html#a47658432f1c3a1cb94d88fbc8047c9a6",
"classqtgui__sink__c.html#a27ed271999698c3eb969e5da6b45a370",
"classuhd__usrp__source.html#a1f635f10493fcaca980afdf715fd357a",
"core__algorithms_8h_source.html",
"dump_8h.html#a6711b540fed88bd990476addbc0cce3b",
"fcdhidcmd_8h.html#aebb4378b8baf6d22799cf2471f484541afbd5836e13d221f6aa3545dca3c4f3e4",
"functions_vars_0x79.html",
"globals_8h.html#a8a31a788b409537ab38f94f2fc5a625a",
"gr__and__const__ss_8h.html",
"gr__fake__channel__coder__pp_8h.html#af6d0acc4010fc06d9f69aee5ccaa05ad",
"gr__integrate__ss_8h_source.html",
"gr__oscope__guts_8h.html",
"gr__sig__source__i_8h.html#ad2ca4c7e341cbe4e93dce3ad47d76027",
"gr__vector__map_8h_source.html",
"group__snr__blk.html#ggad332265a312e8dfe1584460d8859a853a744e64b10fa2a4fe25e2e1aa20846cca",
"inttypes_8h.html#a8b67140c216180e4e5d18003038ee689",
"namespacemembers_func.html",
"pmt_8h.html#a282853f5cd5477fab1717c04a544239d",
"pmt__sugar_8h.html#a9c0c808a7048ad5a985e7320f4d33477",
"simple__squelch__cc__impl_8h_source.html",
"structgr__block__gw__message__type.html#af3d2b10d06d436e1b551fbb37d99dd15",
"vector__to__streams__impl_8h.html",
"volk_8h.html#a53e2266cc75fe0162ee4917d29cdddd5",
"volk__16i__s32f__convert__32f__a_8h_source.html",
"volk__config__fixed_8h.html#a98e67e263bc3d974d79dfa820a7df249"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  var imgNode = document.createElement("img");
  imgNode.style.paddingLeft=(16*level).toString()+'px';
  imgNode.width  = 16;
  imgNode.height = 22;
  imgNode.border = 0;
  if (node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    imgNode.src = node.relpath+"ftv2node.png";
    domNode.appendChild(imgNode);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })

  $(window).load(showRoot);
}

